﻿using System;
using System.Threading;

namespace QuickOPC_Leak
{
    class Program
    {
        /// <summary>
        /// Forced example that creates and disposes an EasyDAClient for every Read operation.
        /// In the real use case, this is only done when we fail to Read or Write tags.
        /// Still, everytime this happens and we try to recreate the Connection object, memory is leaked.
        /// </summary>
        static void Main(string[] args)
        {
            while(true)
            {
                // I expect memory to be freed when disposing this object.
                // Subscription model does not apply to our software architecture.
                using (var conn = new Connection())
                {
                    if (!conn.Open())
                    {
                        Console.WriteLine("Unable to open DA connection.");
                    }

                    if (conn.IsOpen)
                    {
                        if (!conn.Read())
                        {
                            //Connection?.Close();
                            Console.WriteLine("DA Read operation failed.");
                        }
                    }
                }

                Thread.Sleep(1000);
            }
        }
    }
}
